"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// import webpack from 'webpack';
var webpack_sources_1 = require("webpack-sources");
var postcss = require("postcss");
var process_assets_1 = require("./process-assets");
var ExtractCssAssetsPlugin = /** @class */ (function () {
    function ExtractCssAssetsPlugin(options) {
        this.options = Object.assign({
            outputPath: '',
            relativeCssPath: '',
            forceLocal: false,
            requsetOptions: {
                timeout: 5000,
            },
        }, options);
    }
    // eslint-disable-next-line @typescript-eslint/explicit-member-accessibility
    ExtractCssAssetsPlugin.prototype.apply = function (compiler) {
        var options = this.options;
        compiler.hooks.emit.tapPromise('ExtractCssAssetsPlugin', function (compilation) {
            var outputOptions = compilation.outputOptions;
            var collectChunks = []; // 收集资源
            return Promise.all(Object.keys(compilation.assets)
                .map(function (filename) {
                var asset = compilation.assets[filename];
                if (filename.endsWith('.css')) {
                    var css_1 = asset.source();
                    return new Promise(function (resolve) {
                        // @ts-ignore
                        postcss()
                            .use(
                        // @ts-ignore
                        new process_assets_1.default(
                        // @ts-ignore
                        { outputOptions: outputOptions, compilation: compilation, options: options }, {
                            emit: function (chunk) {
                                collectChunks.push(chunk);
                            },
                        }))
                            .process(css_1, { from: filename, to: filename })
                            .then(function (result) {
                            compilation.assets[filename] = new webpack_sources_1.RawSource(result.css);
                            resolve();
                        });
                    });
                }
                return null;
            })
                .filter(Boolean))
                // @ts-ignore
                .then(function () {
                if (collectChunks.length > 0) {
                    return Promise.all(collectChunks.map(function (chunk) {
                        return new Promise(function (resolve, reject) {
                            if (chunk.outputPath) {
                                var file = new webpack_sources_1.RawSource(chunk.contents);
                                compilation.assets[chunk.outputPath] = file;
                                resolve();
                            }
                            else {
                                reject();
                            }
                        });
                    }));
                }
                return Promise.resolve();
            })
                .catch(function (error) {
                throw error;
            });
        });
    };
    return ExtractCssAssetsPlugin;
}());
exports.default = ExtractCssAssetsPlugin;
//# sourceMappingURL=index.js.map